"use strict";
/**********************************************************************************
 * MIT License                                                                    *
 *                                                                                *
 * Copyright (c) 2021 Hyperjump Technology                                        *
 *                                                                                *
 * Permission is hereby granted, free of charge, to any person obtaining a copy   *
 * of this software and associated documentation files (the "Software"), to deal  *
 * in the Software without restriction, including without limitation the rights   *
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell      *
 * copies of the Software, and to permit persons to whom the Software is          *
 * furnished to do so, subject to the following conditions:                       *
 *                                                                                *
 * The above copyright notice and this permission notice shall be included in all *
 * copies or substantial portions of the Software.                                *
 *                                                                                *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR     *
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,       *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE    *
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER         *
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,  *
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE  *
 * SOFTWARE.                                                                      *
 **********************************************************************************/
Object.defineProperty(exports, "__esModule", { value: true });
const test_1 = require("@oclif/test");
const get_1 = require("./get");
describe('Add default notification', () => {
    it('should add default notification', () => {
        // arrange
        const config = {
            probes: [],
        };
        // act
        const newConfig = (0, get_1.addDefaultNotifications)(config);
        // assert
        (0, test_1.expect)(newConfig).deep.eq({
            probes: [],
            notifications: [{ id: 'default', type: 'desktop', data: undefined }],
        });
    });
    it('should add default notification (empty config)', () => {
        // arrange
        const config = {};
        // act
        const newConfig = (0, get_1.addDefaultNotifications)(config);
        // assert
        (0, test_1.expect)(newConfig).deep.eq({
            notifications: [{ id: 'default', type: 'desktop', data: undefined }],
        });
    });
    it('should override existing notification', () => {
        // arrange
        const config = {
            notifications: [
                { id: '1', type: 'webhook', data: { url: 'https://example.com' } },
            ],
        };
        // act
        const newConfig = (0, get_1.addDefaultNotifications)(config);
        // assert
        (0, test_1.expect)(newConfig).deep.eq({
            notifications: [{ id: 'default', type: 'desktop', data: undefined }],
        });
    });
});
//# sourceMappingURL=get.test.js.map