/**********************************************************************************
 * MIT License                                                                    *
 *                                                                                *
 * Copyright (c) 2021 Hyperjump Technology                                        *
 *                                                                                *
 * Permission is hereby granted, free of charge, to any person obtaining a copy   *
 * of this software and associated documentation files (the "Software"), to deal  *
 * in the Software without restriction, including without limitation the rights   *
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell      *
 * copies of the Software, and to permit persons to whom the Software is          *
 * furnished to do so, subject to the following conditions:                       *
 *                                                                                *
 * The above copyright notice and this permission notice shall be included in all *
 * copies or substantial portions of the Software.                                *
 *                                                                                *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR     *
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,       *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE    *
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER         *
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,  *
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE  *
 * SOFTWARE.                                                                      *
 **********************************************************************************/
export declare enum SYMON_API_VERSION {
    'v1' = "v1",
    'v2' = "v2"
}
export type MonikaFlags = {
    'auto-update'?: string;
    config: string[];
    'config-filename': string;
    'config-interval': number;
    'create-config': boolean;
    'native-fetch'?: boolean;
    flush: boolean;
    'follow-redirects': number;
    force: boolean;
    har?: string;
    id?: string;
    insomnia?: string;
    json?: boolean;
    'keep-verbose-logs': boolean;
    logs: boolean;
    'one-probe': boolean;
    output?: string;
    postman?: string;
    prometheus?: number;
    repeat: number;
    retryInitialDelayMs: number;
    retryMaxDelayMs: number;
    sitemap?: string;
    'status-notification'?: string;
    stun: number;
    summary: boolean;
    'symon-api-version'?: SYMON_API_VERSION;
    symonKey?: string;
    symonLocationId?: string;
    symonMonikaId?: string;
    symonReportInterval?: number;
    symonReportLimit?: number;
    symonGetProbesIntervalMs: number;
    symonUrl?: string;
    text?: string;
    ignoreInvalidTLS?: boolean;
    verbose: boolean;
    version: void;
};
export declare const monikaFlagsDefaultValue: MonikaFlags;
export declare const symonAPIVersion: import("@oclif/core/lib/interfaces").FlagDefinition<SYMON_API_VERSION, import("@oclif/core/lib/interfaces").CustomOptions, {
    multiple: false;
    requiredOrDefaulted: true;
}>;
export declare const symonGetProbesIntervalMs: import("@oclif/core/lib/interfaces").OptionFlag<number, import("@oclif/core/lib/interfaces").CustomOptions>;
export declare const retryInitialDelayMs: import("@oclif/core/lib/interfaces").OptionFlag<number, import("@oclif/core/lib/interfaces").CustomOptions>;
export declare const retryMaxDelayMs: import("@oclif/core/lib/interfaces").OptionFlag<number, import("@oclif/core/lib/interfaces").CustomOptions>;
