"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.readFile = void 0;
const pino_1 = require("./pino");
const fs_1 = __importDefault(require("fs"));
// Alternative of fs.readFileSync() API with type safety error NodeJS.ErrnoException
async function readFile(path, encoding) {
    return new Promise((resolve, reject) => {
        fs_1.default.readFile(path, { encoding }, (error, result) => {
            if (error && error?.code === 'ENOENT') {
                pino_1.log.info(`Could not find the file: ${path}. Monika is probably not running or ran from a diffent directory`);
                reject(error);
            }
            else {
                resolve(result);
            }
        });
    });
}
exports.readFile = readFile;
//# sourceMappingURL=read-file.js.map